---
layout: slides
lang: en
theme: moon
transition: fade  # none/fade/slide/convex/concave/zoom
center: false
revealjs-url: http://lab.hakim.se/reveal-js
# fails because CDNs don't serve up /css etc
# revealjs-url: https://cdnjs.cloudflare.com/ajax/libs/reveal.js/3.3.0/js/reveal.min.js
# build with `./build`
# serve the HTML at http://localhost:8000/ with `python -m SimpleHTTPServer`
---


# Making An Impact with Python NLP


# Schedule

- 1:20 Logistics
- 1:30 Introduction
- 1:40 Lesson 1 - Get Tweets
- 2:00 Workshop 1
- 2:20 Lesson 2 - Get Features 
- 2:40 Workshop 2
- 3:00 Refuel (Coffee Break)
- 3:20 Lesson 3 - Machine Learning
- 3:40 Workshop 3
- 4:00 Lesson 4 - Advanced Techniques
- 4:20 Workshop 5
- 4:35 Wrap Up


# Logistics

- WiFi
- Your Development Environment
- Restrooms
- Breaks
- Ask Questions
- Answer Questions
    - Guess
- Play


# Resources

- [Slides](http://totalgood.github.io/talks/2016-05-29-Making-An-Impact-with-Python-Natural-Language Processing-Tools.html)
- [Twip Repo](https://github.com/totalgood/twip)
- [Set up a VirtualBox](https://github.com/talentpair/puppet-python-nlp-tools)
- Development Environment Alternatives
    - [Install Twip from Source](https://github.com/totalgood/twip/install.md#install)
    - `pip install twip`
    - [Installing a VirtualBox](https://github.com/talentpair/puppet-python-nlp-tools)
    - [IDE and Tool Recommendations for your Laptop](https://github.com/hackoregon/hack-university-machine-learning/blob/master/docs/install.md#install)
    - [An Alternative Data Science Toolbox](http://datasciencetoolbox.org/)

- [Data Science Toolbox](http://datasciencetoolbox.org/)


# Team

- Hobson Lane
- Dan Fellin
- Jeremy Robin


# [Hobson Lane](//www.linkedin.com/in/hobsonlane)

<img src="../images/hobson-lane.jpg">

- Aerospace Robotics Engineer for 12 years
- Python Developer for 5 years
- Data Scientist for 4 years


# [Dan Fellin](//www.linkedin.com/in/dan-fellin-611637b6)

<img src="../images/dan-fellin.jpg">

- Software Engineer for 4 years
- API and Web Scraper for 3 years
- Avid Gamer for life


# [Jeremy Robin](//www.linkedin.com/in/jeremyrobin)

<img src="../images/jeremy-robin.jpg">

<small>Jeremy Robin is an engineering executive who has spent more than 10 years building and managing operations, software development, and engineering support services for high technology companies. Before coming to Talentpair, he was the co-founder and director of engineering at Hitpost, a mobile sports network which was acquired by Yahoo. Jeremy holds a BA in Computer Science from Dartmouth and an MS from Stanford.</small>


# [Got Tweets?](1 - Got Tweets.html)


# [Slides Index](.index.html)